%ifarch alpha ppc64 sparc64 x86_64
%define target linux-64
%else
%define target linux
%endif

%define variants thr thr-ogl
%define beta b2

Summary: Parallel / Multiprocessor Ray Tracing System
Name: tachyon
Version: 0.99
Release: 0.2.%{beta}%{?dist}
URL: http://jedi.ks.uiuc.edu/~johns/raytracer/
Group: Applications/Engineering
Source0: http://jedi.ks.uiuc.edu/~johns/raytracer/files/%{version}%{beta}/%{name}-%{version}%{beta}.tar.gz
# taken from Debian package
Source1: %{name}.1
Patch0: %{name}-rpm.patch
Patch1: %{name}-shared.patch
License: BSD with advertising
BuildRoot: %{_tmppath}/%{name}-%{version}-root-%(%{__id_u} -n)
BuildRequires: libGL-devel
BuildRequires: libpng-devel
BuildRequires: libjpeg-devel
BuildRequires: latex2html
BuildRequires: %{_bindir}/dvips
BuildRequires: %{_bindir}/latex
BuildRequires: %{_bindir}/pdflatex

%description
A portable, high performance parallel ray tracing system with
multithreaded implementation.

%package libs
Summary: Parallel / Multiprocessor Ray Tracing System library
Group: System Environment/Libraries

%description libs
A portable, high performance parallel ray tracing system with
multithreaded implementation.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.

This package contains the shared library.

%package gl
Summary: Parallel / Multiprocessor Ray Tracing System with OpenGL display
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description gl
A portable, high performance parallel ray tracing system with
multithreaded implementation.

This package contains OpenGL-enabled build.

%package devel
Summary: Development files for tachyon
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}

%description devel
This package contains development headers and libraries for developing
with tachyon.

%package docs
Summary: Documentation and example scenes for tachyon
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description docs
This package contains documentation and example scenes for rendering
with tachyon.

%prep
%setup -q -n %{name}
%patch0 -p1 -b .r
%patch1 -p1 -b .shared
find . -name CVS | xargs %{__rm} -r
# executable sources
chmod 644 src/hash.{c,h}
chmod 644 src/pngfile.h
chmod 644 demosrc/spaceball.c
chmod 644 demosrc/trackball.{c,h}
chmod 644 scenes/imaps/*

%build
pushd unix
for variant in %{variants} ; do
  %{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" %{target}-$variant
done
popd

pushd docs
%{__make} html pdf ps
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{%{_bindir},%{_libdir},{%{_datadir},%{_includedir}}/tachyon,%{_mandir}/man1}
for variant in %{variants} ; do
  install -pm755 compile/%{target}-$variant/tachyon $RPM_BUILD_ROOT%{_bindir}/tachyon-$variant
done
rename -thr "" $RPM_BUILD_ROOT%{_bindir}/*
mkdir docs/html
%{__cp} -pr docs/tachyon/*.{css,html,png} docs/html
%{__cp} -pr scenes $RPM_BUILD_ROOT%{_datadir}/tachyon/
install -pm644 %{SOURCE1} $RPM_BUILD_ROOT%{_mandir}/man1/
echo ".so tachyon.1" > $RPM_BUILD_ROOT%{_mandir}/man1/tachyon-ogl.1
%{__cp} -a compile/%{target}-thr/libtachyon*.so $RPM_BUILD_ROOT%{_libdir}/
install -pm644 src/{hash,tachyon{,_dep},util}.h $RPM_BUILD_ROOT%{_includedir}/tachyon/

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*

%files libs
%defattr(644,root,root,755)
%doc Copyright README
%{_libdir}/libtachyon-%{version}.so

%files gl
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{name}-ogl
%{_mandir}/man1/%{name}-ogl.1*

%files devel
%defattr(644,root,root,755)
%{_includedir}/tachyon
%{_libdir}/libtachyon.so

%files docs
%defattr(644,root,root,755)
%doc Changes docs/tachyon.pdf docs/tachyon.ps docs/html
%{_datadir}/tachyon

%changelog
* Sat Jul 23 2011 Dominik Mierzejewski <rpm@greysector.net> 0.99-0.2.b2
- install missing tachyon_dep.h header
- link shared library against libjpeg to avoid unresolved symbols

* Sun Apr 10 2011 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.99-0.1.b2
- updated to 0.99b2
- rebased patch
- updated BRs

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.98.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Feb 09 2010 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98.9-1
- update to 0.98.9

* Sat Dec 26 2009 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98.7-2
- drop LAM support
- add shared library (based on Debian patch)
- simplify some specfile constructs
- improve descriptions

* Sun Sep 20 2009 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98.7-1
- update to 0.98.7 release
- simplify specfile ifdeffery and reduce patch size
- fix build with new environment-modules
- add manpage from Debian package

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.98.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat Feb 28 2009 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98.1-1
- update to 0.98.1 release
- fix mixed-up summaries
- docs are now built separately

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.98-0.8.20070319
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Sep 26 2008 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.7.20070319
- fix build with new lam package
- use generic BR for libGLU-devel
- move tree cleanup to %%prep to fix short-circuit builds

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.98-0.6.20070319
- Autorebuild for GCC 4.3

* Thu Dec 13 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.5
- more seamless variant handling
- use proper lam cflags and ldflags (as reported by pkgconfig)

* Tue Dec 04 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.4
- add support for Alpha

* Wed Aug 29 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.3
- rebuild
- update license tag

* Sat Jul 14 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.2
- add support for ppc64 and sparc64, simplify target setting

* Sat Jul 07 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.1
- update to 0.98 pre-release

* Sun Dec 17 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-4
- fix copy&paste error in patch

* Sun Dec 17 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-3
- add SPARC support

* Wed Nov 29 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-2
- use only kosher CFLAGS
- fix target setting

* Tue Nov 28 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-1
- initial build
- patch to add necessary build targets
